#
# map3d2.rb
#   $Id: map3d2.rb,v 1.1 2000/11/18 19:03:39 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math


NX = 37
NY = 37
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = 90
DRAD = PI/180
p = NArray.sfloat(NX, NY)

#-- data ---
for j in 0..NY-1
  for i in 0..NX-1
    alon = ( XMIN + (XMAX-XMIN)*i/(NX-1) ) * DRAD
    alat = ( YMIN + (YMAX-YMIN)*j/(NY-1) ) * DRAD
    slat = sin(alat)
    p[i,j] = 3*sqrt(1-slat**2)*slat*cos(alon) - 0.5*(3*slat**2-1)
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

sglset('LSOFTF', false)
grfrm

sgswnd(XMIN, XMAX, YMIN, YMAX)
sgsvpt(0.1, 0.9, 0.1, 0.9)
sgssim(0.4, 0.0, 0.0)
sgsmpl(135.0, 35.0, 0.0)
sgstxy(-180.0, 180.0, 0.0, 90.0)
sgstrn(30)
sgstrf

for k in -5..3
  tlev1 = 0.4*k
  tlev2 = tlev1 + 0.4
  if (k <= -1)
    ipat = 600 + (k+1).abs
  else
    ipat =  30 + k
  end
  uestlv(tlev1, tlev2, ipat)
end

uetone(p, NX, NX, NY)

udgclb(p, NX, NX, NY, 0.4)
udcntr(p, NX, NX, NY)

umpmap('coast_world')
umpglb

grcls

